function [P,G] = splines(X,k)
n = length(X);
P = zeros(n,k);
G = zeros(n,k);
P(:,1) = ones(n,1);
P(:,2) = X;
if k > 2
    P(:,3) = X.^2;
end
for j=4:k
    P(:,j) = (max(X - (j-3)/(k-2),0)).^2;
end
G(:,2) = ones(n,1);
if k > 2
    G(:,3) = 2*X;
end
for j=4:k
    G(:,j) = 2*max(X - (j-3)/(k-2),0);
end